import { world, EffectTypes, system } from "@minecraft/server"

let eagleCarryable = [
    'minecraft:wolf',
    'minecraft:rabbit',
    'minecraft:pig'
]

world.afterEvents.entityHurt.subscribe((ev) => {
    if (ev.damageSource.damagingEntity.typeId == 'anc:grizzly_bear') {
        ev.hurtEntity.addEffect(EffectTypes.get('slowness'), 20, { amplifier: 255 })
        ev.hurtEntity.addEffect(EffectTypes.get('weakness'), 20, { amplifier: 255 })
    }
    if (ev.damageSource.damagingEntity.typeId == 'anc:american_alligator' && ev.damageSource.damagingEntity.getComponent('variant').value == 3 && !ev.damageSource.damagingEntity.getComponent('is_sheared')) {
        ev.damageSource.damagingEntity.triggerEvent('anc:start_spin_attacking')
        ev.hurtEntity.addTag('gatorTarget')
        ev.damageSource.damagingEntity.runCommandAsync(`ride @e[tag=gatorTarget, c=1] start_riding @s teleport_rider`)
        ev.hurtEntity.addEffect(EffectTypes.get('weakness'), 60, { amplifier: 255 })
        // setTimeout(() => {
        //     ev.hurtEntity.removeTag('gatorTarget')
        // }, 1000)
    }
    if (ev.damageSource.damagingEntity.typeId == 'anc:american_alligator' && ev.damageSource.damagingEntity.getComponent('is_sheared')) {
        ev.hurtEntity.addEffect(EffectTypes.get('weakness'), 60, { amplifier: 255 })
    }
    if (ev.damageSource.damagingEntity.typeId == 'mbcreatures:puma' && ev.damageSource.damagingEntity.getComponent('health').current <= ev.damageSource.damagingEntity.getComponent('health').value * 0.25 && !!ev.damageSource.damagingEntity.target) {
        ev.damageSource.damagingEntity.triggerEvent('mbcreatures:start_low_health_attacking')
    }
    if (ev.damageSource.damagingEntity.typeId == 'anc:eagle' && eagleCarryable.includes(ev.hurtEntity.typeId)) {
        ev.hurtEntity.addTag('eagleTarget')
        ev.damageSource.damagingEntity.triggerEvent('anc:grab_mob')
        ev.damageSource.damagingEntity.runCommandAsync(`ride @e[tag=eagleTarget, c=1] start_riding @s teleport_rider`)
        // setTimeout(() => {
        //     ev.hurtEntity.removeTag('eagleTarget')
        // }, 1000)
    }
})

world.afterEvents.dataDrivenEntityTriggerEvent.subscribe((ev) => {
    if (ev.entity.typeId == 'anc:eagle' && ev.id == 'anc:get_target' && eagleCarryable.includes(ev.entity.target.typeId)) {
        ev.entity.triggerEvent('anc:target_is_carryable')
    }
    if (ev.entity.typeId == 'anc:eagle' && ev.id == 'anc:get_target' && !eagleCarryable.includes(ev.entity.target.typeId)) {
        ev.entity.triggerEvent('anc:target_is_uncarryable')
    }
    if (ev.entity.typeId == 'anc:eagle' && ev.id == 'anc:carrying') {
        ev.entity.applyImpulse({
            x: 0,
            y: 0.25,
            z: 0
        })
    }
})

system.runInterval(() => {
    let entities = Array.from(world.getDimension('overworld').getEntities())
    mainloop: for (let e = 0; e < entities.length; e++) {
        if (entities[e].typeId == 'mbcreatures:grizzly_bear' && !entities[e].getComponent('is_sheared') && !entities[e].getComponent('is_charged')) {
            for (let x = -1; x < 2; x++) {
                for (let y = -1; y < 3; y++) {
                    for (let z = -1; z < 2; z++) {
                        if (entities[e].dimension.getBlock(entities[e].location).typeId == 'minecraft:bee_nest') {
                            entities[e].triggerEvent('mbcreatures:destroy_beehive')
                            continue mainloop
                        }
                    }
                }
            }
        }
        if (entities[e].typeId == 'mbcreatures:puma' && entities[e].getComponent('is_sheared') && !!entities[e].target) {
            entities[e].target.teleport(entities[e].location, world.getDimension('overworld'), 0, 0)
        }
        if (entities[e].typeId == 'mbcreatures:puma' && entities[e].getComponent('health').current <= entities[e].getComponent('health').value * 0.25 && !entities[e].target) {
            entities[e].triggerEvent('mbcreatures:stop_low_health_attacking')
        }
    }
}, 20)